library(reshape2)
library(stringr)

# Load -----------------------------------------------------------------------
raw <- read.csv("tb.csv", stringsAsFactors = FALSE)
raw$new_sp <- NULL
names(raw) <- str_replace(names(raw), "new_sp_", "")


# Melt -----------------------------------------------------------------------

tidy <- melt(raw, id = c("iso2", "year"), na.rm = TRUE)
names(tidy)[4] <- "cases"
tidy <- arrange(tidy, iso2, variable, year)

# Break up variable in to sex and age ----------------------------------------


ages <- c("04" = "0-4", "514" = "5-14", "014" = "0-14", "1524" = "15-24", "2534" = "25-34", "3544" = "35-44", "4554" = "45-54", "5564" = "55-64", "65"= "65+", "u" = NA)

tidy$sex <- str_sub(tidy$variable, 1, 1)
tidy$age <- factor(ages[str_sub(tidy$variable, 2)], levels = ages)
tidy$variable <- NULL

tidy <- tidy[c("iso2", "year", "sex", "age", "cases")]
